package com.tmax.openframe.variable.group;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @AllArgsConstructor @NoArgsConstructor @Builder(builderClassName = "builder") class COBTEST2_RVL_REC {
    public @Getter @Setter @Builder.Default COBTEST2_RVL_KEY RVL_KEY = new COBTEST2_RVL_KEY();
    public @Getter @Builder.Default String RVL_LCYM = StringUtils
            .repeat(' ', 6);
    public @Getter @Setter int RVL_LPMT;
    private final static BiFunction<Long, String, String> intFormatWithoutSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.setNegativePrefix("");
        nf.applyPattern(format);
        return nf.format(value);
    };

    public void setRVL_LCYM(String source) {
        RVL_LCYM = StringUtils.truncate(StringUtils.rightPad(source, 6), 6);
    }

    public String getStringRVL_LPMT() {
        return intFormatWithoutSign.apply((long) RVL_LPMT, "00000");
    }

    @Override
    public String toString() {
        return getRVL_KEY().toString() + getRVL_LCYM() + getStringRVL_LPMT();
    }
}
